=== cmake/debian/changelog ===
uhd (3.11.0.1-0ubuntu1) trusty; urgency=low

  * N300: Added driver support (includes some refactoring of N3xx
    codebase)
  * MPM: Fix PyLint warnings, Fix error handling for TCA communication
    errors, Fix printout of AD9371 version
  * uhd_images_downloader: Create unique archive names for images archives
    (now include git hashes in the filename)
  * uhd_images_downloader: Fix SHA256 check
  * utils: Add support for N3xx filesystem images to images downloader
  * UHD: Minor logging fixes
  * UHD: fix legacy compat to work with 2TX radio block
  * X300: improve lvbitx bitstream md5 read time
  * examples: Enhance benchmark_rate with more stats and timestamps for errors
  * cmake: Correctly fail when an unavailable component is requested
  * debian: Add UHDConfig.cmake to install list for libuhd-dev

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.11.0.0-0ubuntu1) trusty; urgency=low

  * N310: Added driver
  * UBX: Add support for CAL antenna for Rev E
  * Added the module peripheral manager (MPM) with all subcomponents (N310
    drivers, mpm_shell, RPC server, BIST, etc.)
  * UHD: Added rpclib as a internally tracked dependency
  * UHD: Reduced the usage of Boost
  * UHD: Updated uhd_images_downloader: Now uses more elaborate manifest to
    optimize downloads
  * UHD: Introduced uhdlib internal include paths
  * UHD: Add support for configuration files. USRP settings can now be set using
    a uhd.conf file in addition to device args
  * UHD: Add narrow and narrow_cast
  * gr-usrptest: Various bugfixes
  * Updated required Vivado version to 2017.4
  * Updated all license headers to use SPDX identifiers and correctly identify
    Ettus Research as part of National Instruments
  * This release includes all bugfixes and features from previous releases, in
    particular, the 3.10.* release cycle

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.10.3.0-0ubuntu1) trusty; urgency=low

  * X300
  ** Fix max rate calculation for 1 GbE
  ** Fix for DAC synchronization errors (unexpected FIFO depth)
  ** Reduced CPU usage during TX
  * N230
  ** Properly initialize request structure before discovery
  * B200
  ** FX3 firmware performance opitimizations
  ** Fixed sequence error on second TX burst
  * TwinRX
  ** Added ADF5356 synth and Rev C support
  * UBX
  ** Add implementation of TDD xcvr_mode and for TX PA on in TDD mode (to reduce transient on older revs)
  ** Add support for UBX-TDD
  * C API
  ** Fixed dboard EEPROM revision error handling
  ** Make uhd_rx_streamer_last_error use SAFE_C
  ** Better error handling in uhd_usrp_get_[t/r]x_stream
  * RFNoC
  ** Fix ctrl_iface to pop sequence numbers only after success
  ** Fix sequence number error message in ctrl_iface
  ** FPGA fix for sr_read() failure to ack errors
  ** FPGA fix for repeated sequence number for RX packets with 1 sample
  ** FPGA fix for axi_serializer edge case
  * Docs
  ** Fixed B200 power LED description
  ** Update README application links
  * UHD
  ** Utilize poll() instead of select() for UDP transports where possible to avoid descirptor limits
  ** Fix build with Boost 1.66
  ** Add EEPROM info to dboard_base class so daughterboard code can access all EEPROM info

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.9.5-0ubuntu1) trusty; urgency=low

  * B200: Update DSPs after changing tick rate
  * X300: Added option to disable ADC self test, prevent DAC from
    underrunning
  * UBX: Fixed noise issues, reduced power consumption/heat, added codes for
    upcoming board revisions, force RX LNAs on (reduces rx settling time)
  * WBX: Fixed rev2 and rev3 boards on X300
  * Utils/Examples: Cleaned up query_gpsdo_sensors, test_dboard_coercion,
  * Manual: Minor fixes and updates
  * CMake: Fix lib64 detection, better platform detection, Doxygen may use shorter
    filenames
  * Octoclock: GPSDO-related fixes, sequence number consistency fixes, UART
    fixes (off-by-one errors). uhd_usrp_probe will pick up an OC now,
    added Wireshark dissector for OC packets

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.9.4-0ubuntu1) trusty; urgency=low

  * GPIO control: Fix address mismatch for RX and full duplex.
    This fixes full-duplex mode for most devices.
  * B200: Fixed auto rate selection (can now select 61.44 Msps)
  * UBX: Fix member declaration order which could cause
    segfaults for debug builds
  * Manual/Docs: Numerous fixes, use dot for graphs in manual
  * Utils: multiple fixes for query_gpsdo_sensors, fixed floating point
    comparison
  * Windows: Include registry file in installation
  * Converters: Improve NEON converters

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.9.2-0ubuntu1) trusty; urgency=low

  * E310: Added support for Speedgrade 3
  * B205mini: Added support
  * E310: Fixed reference counting bug
  * B210: Fixed external clock reference bug for devices using ADF4002 PLLs
  * B210: Fixed codec loopback test
  * OctoClock: Fixed firmware burning on Windows
  * B2XX, E3XX, X3XX: Easier time-syncing features. Fixes bug where B210s would
    only run after issuing set_time_unknown_pps().
  * X3XX: Fixed bug for IQ imbalance correction
  * E310: DRAM testbenching
  * Docs/Manual: Many updates and fixes

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.9.1-0ubuntu1) trusty; urgency=low

  * B200mini: Updated udev rules, removed DCM
  * B200: Better USB error messages
  * Cores: Fixed CORDIC scaling issue on all devices that use
    dsp_core_3000
  * X300: Fixed GPIO issue
  * Examples: Added PPS source option
  * Docs: Multiple manual updates

 -- Ettus Research <packages@ettus.com>  Wed, 28 Mar 2018 03:28:36 -0800

uhd (3.9.0-0ubuntu1) trusty; urgency=low

  * X300: Updated DAC ctrl, FPGA toolchain is now entirely Vivado,
    improved master clock controls, added ADC self-cal capability,

